
<p>Ideja minimizacije jest ukloniti nepotrebno sklopovlje iz sklopovskog ostvarenja. Želimo ostvarenje koje je pojednostavljeno do najveće mjere. Centralnu ulogu u postupcima minimizacije (i naš najvažniji alat u tome) jest <em>teorem simplifikacije</em>. Sjećate li ga se? Idemo ga ponoviti još jednom. Teorem simplifikacije kaže da vrijedi sljedeća jednakost:
$$
 \phi \cdot A + \phi \cdot \bar A = \phi \quad \quad \text{(T1a)}
$$
odnosno njezin dual:
$$
 (\phi + A) \cdot (\phi + \bar A) = \phi .  \quad \quad \text{(T1b)}
$$
Uočite da s lijeve strane jednakosti imamo algebarski izraz za koji trebamo tri logička sklopa; s desne strane ne trebamo niti jedan logički sklop. To je ideja pojednostavljivanja.</p>

<p>Napravit ćemo dva primjera algebarske minimizacije. U oba primjera mjera koju minimiziramo namjerno nije izrečena - idemo se malo igrati s algebarskim zapisom da vidimo do čega možemo doći.</p>

<h3>Primjer 1.</h3>

<p>Zadana je Booleova funkcija \(f(A,B,C)=\bar A \bar B \bar C + \bar A \bar B C + \bar A B \bar C + A B \bar C\). Sklopovsko ostvarenje ove Booleove funkcije prikazano je na slici u nastavku.</p>

<figure class="mlFigure">
<img src="@#file#(shema1a.svg)" alt="Izravno ostvarenje funkcije prema zadanom izrazu."><br>
<figcaption><span class="mlFigKey">Slika 1.a.</span> Izravno ostvarenje funkcije prema zadanom izrazu.</figcaption>
</figure>

<p>Pogledajmo sada što možemo napraviti s ovim algebarskim oblikom.
$$
\begin{align}
 f(A,B,C) &amp;= \bar A \bar B \bar C + \bar A \bar B C + \bar A B \bar C + A B \bar C \\
          &amp;= \bar A \bar B \cdot (\bar C + C) + (\bar A + A) \cdot B \bar C   &amp;&amp; \text{distributivnost množenja prema zbrajanju} \\
          &amp;= \bar A \bar B \cdot 1 + 1 \cdot B \bar C   &amp;&amp; \text{svojstvo komplementa} \\
          &amp;= \bar A \bar B + B \bar C   &amp;&amp; \text{1 je neutralni element za množenje} \\
          &amp;= (\bar A \bar B + B) \cdot (\bar A \bar B + C)   &amp;&amp; \text{distributivnost zbrajanja prema množenju} \\
          &amp;= (\bar A + B) \cdot (\bar B + B) \cdot (\bar A + C) \cdot (\bar B + C)   &amp;&amp; \text{distributivnost zbrajanja prema množenju} \\
          &amp;= (\bar A + B) \cdot 1 \cdot (\bar A + C) \cdot (\bar B + C)   &amp;&amp; \text{svojstvo komplementa} \\
          &amp;= (\bar A + B) \cdot (\bar A + C) \cdot (\bar B + C)   &amp;&amp; \text{1 je neutralni element za množenje} \\
          &amp;= (\bar A + B) \cdot (\bar A + C + 0) \cdot (\bar B + C)   &amp;&amp; \text{0 je neutralni element za zbrajanje} \\
          &amp;= (\bar A + B) \cdot (\bar A + C + B \cdot \bar B) \cdot (\bar B + C)   &amp;&amp; \text{svojstvo komplementa} \\
          &amp;= (\bar A + B) \cdot (\bar A + C + B) \cdot (\bar A + C + \bar B) \cdot (\bar B + C)   &amp;&amp; \text{distributivnost zbrajanja prema množenju} \\
          &amp;= (\bar A + B) \cdot (\bar A + B + C) \cdot (\bar B + C) \cdot (\bar B + C + \bar A)   &amp;&amp; \text{komutativnost} \\
          &amp;= (\bar A + B) \cdot (\bar B + C)   &amp;&amp; \text{apsorpcija} \\
\end{align}
$$
U ovom primjeru radili smo korak po korak ne oslanjajući se na teorem simplifikacije. Pogledajte sada prvi redak, prva dva člana koja se zbrajaju: \(\bar A \bar B \bar C + \bar A \bar B C\). Uz \(\phi = \bar A \bar B\) zapravo piše \(\phi \cdot \bar C + \phi \cdot C\) što znamo da je prema teoremu simplifikacije jednako \(\phi\) odnosno \(\bar A \bar B\). Druga dva pribrojnika su istog oblika: \(\bar A B \bar C + A B \bar C\) gdje je sada \(\phi=B \bar C\) pa imamo \(\bar A \cdot \phi + A \cdot \phi\) što je po teoremu simplifikacije jednako \(\phi\) odnosno \(B \bar C\). Time iz prvog retka uporabom teorema simplifikacije izravno možemo doći do četvrtog retka i zaključiti da možemo pisati:
$$
  f(A,B,C) = \bar A \bar B + B \bar C.
$$
Ovaj oblik predstavlja ostvarenje dane funkcije dvorazinskom logikom u minimalnom zapisu sume produkata; manje od ovoga u ovom obliku ne ide. Ostvarenje je prikazano na slici u nastavku.
</p>

<figure class="mlFigure">
<img src="@#file#(shema1b.svg)" alt="Ostvarenje funkcije kao minimalna suma produkata."><br>
<figcaption><span class="mlFigKey">Slika 1.b.</span> Ostvarenje funkcije kao minimalna suma produkata.</figcaption>
</figure>

<p>Nakon četvrtog retka primjenom distributivnosti zbrajanja prema množenju krenuli smo prema obliku koji je produkt suma. Peti redak jest produkt suma ali neki članovi suma su novi produkti pa to nije dvorazinski produkt suma. Stoga uporabom još nekoliko postulata i teorema dolazimo do retka 8 u kojem imamo zapis funkcije kao dvorazinski produkt suma:
$$
  f(A,B,C) = (\bar A + B) \cdot (\bar A + C) \cdot (\bar B + C).
$$
Taj zapis, međutim, nije minimalan. Ako Vam nije jasno zašto, to je OK - malo tko iz ovog algebarskog zapisa to može vidjeti - i to je razlog zašto se u praksi ne radi algebarska minimizacija ručno; nikad ne znate jeste li gotovi ili ne. Da bismo došli do minimalnog oblika, srednjoj sumi treba dodati 0 i nju treba prikladno raspisati kao umnožak B i njegovog komplementa (da, da, to je jedna od onih situacija kad u matematici nešto dokazujete pa stvar pomnožite s 1 ili dodate 0 i onda se magija dogodi, a da ste probali bio što drugo, ništa ne bi radilo; ali nedajte se isfrustrirati, i ovo je nešto što gotovo nitko ne vidi iz prve i to je OK; kad naučimo minimizaciju K-tablicama, onda ćete iz K-tablice vidjeti da je baš ovaj član onaj kojeg se može i treba uništiti i od tamo ćete znati da ovdje treba napraviti baš ovo; stoga za sada samo pratite algebarske manipulacije i uvjerite se da su one ispravne).</p>

<p>Kroz nekoliko koraka dolazimo do pretposljednjeg retka u kojem stoji: \((\bar A + B) \cdot (\bar A + B + C) \cdot (\bar B + C) \cdot (\bar B + C + \bar A)\). Sada je važno da se prisjetite teorema apsorpcije koji kaže da je \(x + xy = x\) odnosno dualno \(x \cdot (x+y) = x\). Ovdje je izravno primjenjiv ovaj dualni oblik. Pogledajte u retku koji smo izdvojili prva dva člana i uočite da je u njima \(x=\bar A + B\) pa zapravo piše \(x \cdot (x+C)\) što je naravno \(x\), odnosno \(\bar A + B\). Isti teorem druga dva člana razrješava u \(\bar B + C\), čime dolazimo do posljednjeg retka u kojem imamo:
$$
  f(A,B,C) = (\bar A + B) \cdot (\bar B + C).
$$
Ovaj oblik predstavlja ostvarenje dane funkcije dvorazinskom logikom u minimalnom zapisu produkta suma; manje od ovoga u ovom obliku ne ide. Ostvarenje je prikazano na slici u nastavku.
</p>

<figure class="mlFigure">
<img src="@#file#(shema1c.svg)" alt="Ostvarenje funkcije kao minimalni produkt suma."><br>
<figcaption><span class="mlFigKey">Slika 1.c.</span> Ostvarenje funkcije kao minimalni produkt suma.</figcaption>
</figure>

<h3>Primjer 2.</h3>

<p>Zadana je Booleova funkcija \(f(A,B,C)=\bar A \bar B \bar C + \bar A \bar B C + \bar A B \bar C + A B \bar C + A B C\). Sklopovsko ostvarenje ove Booleove funkcije prikazano je na slici u nastavku.</p>

<figure class="mlFigure">
<img src="@#file#(shema2a.svg)" alt="Izravno ostvarenje funkcije prema zadanom izrazu."><br>
<figcaption><span class="mlFigKey">Slika 2.a.</span> Izravno ostvarenje funkcije prema zadanom izrazu.</figcaption>
</figure>

<p>Pogledajmo sada što možemo napraviti s ovim algebarskim oblikom.
$$
\begin{align}
 f(A,B,C) &amp;= \bar A \bar B \bar C + \bar A \bar B C + \bar A B \bar C + A B \bar C + A B C\\
          &amp;= \bar A \bar B \bar C + \bar A \bar B C + \bar A B \bar C + A B \bar C + A B \bar C + A B C  &amp;&amp; \text{idempotentnost}\\
          &amp;= \bar A \bar B \cdot (\bar C + C) + (\bar A + A) \cdot B \bar C + A B \cdot (\bar C + C)  &amp;&amp; \text{distributivnost množenja prema zbrajanju} \\
          &amp;= \bar A \bar B + B \bar C + A B   &amp;&amp; \text{svojstvo komplementa, neutralni element} \\
          &amp;= B(A + \bar C) + \bar A \bar B   &amp;&amp; \text{distributivnost množenja prema zbrajanju} \\
          &amp;= (\bar A \bar B + B) \cdot (\bar A \bar B + A + \bar C)   &amp;&amp; \text{distributivnost zbrajanja prema množenju} \\
          &amp;= (\bar A + B) \cdot (\bar B + B) \cdot (\bar A + A + \bar C) \cdot (\bar B + A + \bar C)   &amp;&amp; \text{distributivnost zbrajanja prema množenju} \\
          &amp;= (\bar A + B) \cdot 1 \cdot (1 + \bar C) \cdot (\bar B + A + \bar C)   &amp;&amp; \text{svojstvo komplementa} \\
          &amp;= (\bar A + B) \cdot 1 \cdot 1 \cdot (\bar B + A + \bar C)   &amp;&amp; \text{dominacija} \\
          &amp;= (\bar A + B) \cdot (A + \bar B + \bar C)   &amp;&amp; \text{1 je neutralni element za množenje, komutativnost} \\
\end{align}
$$
U retku 4 došli smo do minimalnog zapisa u obliku dvorazinske sume produkata:
$$
  f(A,B,C) = \bar A \bar B + B \bar C + A B.
$$
Ovo ostvarenje prikazano je na slici u nastavku.
</p>

<figure class="mlFigure">
<img src="@#file#(shema2b.svg)" alt="Minimalna suma produkata."><br>
<figcaption><span class="mlFigKey">Slika 2.b.</span> Ostvarenje funkcije kao minimalna suma produkata.</figcaption>
</figure>

<p>U retku 10 došli smo do minimalnog zapisa u obliku dvorazinskog produkta suma:
$$
  f(A,B,C) = (\bar A + B) \cdot (A + \bar B + \bar C).
$$
Ovo ostvarenje prikazano je na slici u nastavku.
</p>

<figure class="mlFigure">
<img src="@#file#(shema2d.svg)" alt="Minimalni produkt suma."><br>
<figcaption><span class="mlFigKey">Slika 2.c.</span> Ostvarenje funkcije kao minimalni produkt suma.</figcaption>
</figure>

<div class="mlImportant"><p>
Uočite da za istu zadanu funkciju ostvarenje kao minimalna suma produkata te ostvarenje kao minimalni produkt suma nisu nužno jednako složeni (odnosno skupi). Ovo je bio lijep primjer funkcije koja se može jeftinije ostvariti u obliku produkta suma (trebamo samo tri logička sklopa) no što je to slučaj sa sumom produkata (koja treba četiri logička sklopa). Stoga ako tražite minimalno ostvarenje funkcije dvorazinskom logikom (i koristite samo sklopove I i ILI), treba pogledati oba oblika.
</p>
</div>



